Create a Chart in jQuery

FusionTime is a JavaScript charting library that helps you visualize and explore time-series data. In FusionTime, you get lots of out-of-the-box interactive features, such as time navigator, date range selectors, tooltips with crosslines, interactive legend, and more. These features enhance the experience of exploring and understanding time series data.

We have built a simple jquery-fusioncharts plugin which provides bindings for FusionTime. The jquery-fusioncharts plugin allows you to easily add interactive time-series charts to any jQuery project.

In this page, we'll see how to install FusionTime and render an interactive time-series chart using the jquery-fusioncharts plugin.

Installation

Since FusionTime is distributed along with FusionCharts Suite, download/install the FusionCharts package to get access to FusionTime. To install follow the steps below:

To install fusiontime and the jquery-fusioncharts module via npm follow the steps below:
1. Install the jquery-fusioncharts module.

$ npm install jquery-fusioncharts --save

2. Install fusioncharts package

$ npm install fusioncharts --save

To install fusiontime and the jquery-fusioncharts module follow the steps below:
  1. Include the jquery core library.
  2. Include the jquery-fusioncharts module.
  3. Include the FusionCharts JavaScript files from CDN.
  4. Include the fusiontime file to render time-series charts.

<head>
    <script type="text/javascript" src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
    <script type="text/javascript" src="https://unpkg.com/fusioncharts/fusioncharts.js"></script>
    <script type="text/javascript" src="https://unpkg.com/[email protected]/fusioncharts.timeseries.js"></script>
    <script type="text/javascript" src="https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"></script>
</head>

To install fusiontime and the jquery-fusioncharts component follow the steps below:
  1. Include the jQuery core library.
  2. Include the jquery-fusioncharts module.
  3. Include the FusionCharts JavaScript files locally.
  4. Include the fusiontime file to render time-series charts.
The consolidated code is shown below:

<head>
    <script type="text/javascript" src="path/to/local/jquery-3.3.1.min.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.timeseries.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.jqueryplugin.min.js"></script>
</head>

Create Your First Chart

Let's create a time-series chart using jquery-fusioncharts component showing Daily sales of a grocery store.

The chart will look as shown below:

Loading data for chart…

The data for the above chart is too big to be displayed here. The table below shows the sample data of the above chart:

Time Sales
1/4/2011 16.448
1/5/2011 272.736
1/5/2011 11.784
1/5/2011 3.54
1/6/2011 19.536
1/7/2011 2573.82
1/7/2011 609.98

FusionTime accepts a DataTable as the data source. DataTable is the tabular representation of data. To create the DataTable, you need to provide the following:

  • schema - which defines the properties of the columns.
  • data - which contains the values of each row and column of the DataTable.

For an instance of FusionTime, you can create n number of DataTables, but only one DataStore.

Now, let's learn how to prepare the schema and the data of the DataTable.

Create the schema

The schema outlines each column represented in the above table. The schema contains an array which has multiple objects created in it. Each object represents a column of the above table.

name and type are mandatory keys for each object. If the object type is time then format is also a mandatory key.

To define the schema, let's create a schema.json file and copy the following code:

It is not mandatory to create the schema in a different .json file. You can also define the schema within the .html file.

[{
    "name": "Time",
    "type": "date",
    "format": "%-m/%-d/%Y"
}, {
    "name": "Sales",
    "type": "number"
}]

In the above code:

  • schema is the variable in which the array is stored.
  • Each object of a schema maps to a column of the tabular representation of the data.
  • The JSON object has the following attributes:
    • name - Specify the name of the column of the tabular representation of data
    • type - Specify the type of the column.
    • format - Specify the input format of the date as per your data. In this example, the format is %-m/%-d/%Y. To know more on date formats click here.

Now that we have the schema ready, let's work on the data.

Create data

Data can be provided either in JSON format or 2D array format. We will use the 2D array format.

Data for the above chart is too big to be shown here. A sample of it has been used in the data object defined below:

[
    [
        "1/4/2011",
        16.448
    ],
    [
        "1/5/2011",
        272.736
    ],
    [
        "1/5/2011",
        11.784
    ],
    [
        "1/5/2011",
        3.54
    ],
    [
        "1/6/2011",
        19.536
    ],
    [
        "1/7/2011",
        2573.82
    ],
]

Create a new data.json file, and copy the above code there. Next, copy the entire data and replace it with the content of the data object in your 'data.json' file.

It is not mandatory to create a data.json file. You can also do the same in your HTML file.

In the above code:

  • data is the variable in which the data array is stored.
  • Each object in the data array corresponds to a row in the tabular representation of the data.
  • Each element in an object is represented by each object of the schema. The values in each object of the array represent the following:
    • Time according to the format
    • Total Sales amount

We are all set with our data to create the chart.

By default, FusionTime applies the average function to aggregate the data and display on the chart. You can change the aggregate function from average to any other numeric calculation. To know more click here.

Now, let's create the files to render the above chart.

Render the chart

To render the chart, create a .js file and copy the following code:


const $ = require('jquery');
const TimeSeries = require('fusioncharts/fusioncharts.timeseries');
const FusionCharts = require('fusioncharts');
const jQueryFusionCharts = require('jquery-fusioncharts');

TimeSeries(FusionCharts); // Resolve TimeSeries as dependency for FusionCharts.
jQueryFusionCharts(FusionCharts); // Resolve FusionCharts as dependency for jqueryFusionCharts.

var jsonify = res => res.json();
var dataFetch = fetch(
  'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
).then(jsonify);
var schemaFetch = fetch(
  'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
).then(jsonify);

Promise.all([dataFetch, schemaFetch]).then(res => {
  const data = res[0];
  const schema = res[1];
  // First we are creating a DataStore
  const fusionDataStore = new FusionCharts.DataStore();
  // After that we are creating a DataTable by passing our data and schema as arguments
  const fusionTable = fusionDataStore.createDataTable(data, schema);

  $('document').ready(function() {
    $('#chart-container').insertFusionCharts({
      type: 'timeseries',
      width: '600',
      height: '400',
      dataFormat: 'json',
      dataSource: {
        data: fusionTable,
        caption: {
          text: 'Sales Analysis'
        },
        subcaption: {
          text: 'Grocery'
        },
        yAxis: [
          {
            plot: {
              value: 'Grocery Sales Value',
              type: 'line'
            },
            format: {
              prefix: '$'
            },
            title: 'Sale Value'
          }
        ]
      }
    });
  });
});

Use a bundler browserify, to bundle the script. Click here to know more.

$ browserify script.js -o bundle.js


var jsonify = res => res.json();
var dataFetch = fetch(
    'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
).then(jsonify);
var schemaFetch = fetch(
    'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
).then(jsonify);

Promise.all([dataFetch, schemaFetch]).then(res => {
    const data = res[0];
    const schema = res[1];
    // First we are creating a DataStore
    const fusionDataStore = new FusionCharts.DataStore();
    // After that we are creating a DataTable by passing our data and schema as arguments
    const fusionTable = fusionDataStore.createDataTable(data, schema);

    $('document').ready(function() {
        $('#chart-container').insertFusionCharts({
            type: 'timeseries',
            width: '600',
            height: '400',
            dataFormat: 'json',
            dataSource: {
                data: fusionTable,
                caption: {
                    text: 'Sales Analysis'
                },
                subcaption: {
                    text: 'Grocery'
                },
                yAxis: [{
                    plot: {
                        value: 'Grocery Sales Value',
                        type: 'line'
                    },
                    format: {
                        prefix: '$'
                    },
                    title: 'Sale Value'
                }]
            }
        });
    });
});


var jsonify = res => res.json();
var dataFetch = fetch(
    'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
).then(jsonify);
var schemaFetch = fetch(
    'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
).then(jsonify);

Promise.all([dataFetch, schemaFetch]).then(res => {
    const data = res[0];
    const schema = res[1];
    // First we are creating a DataStore
    const fusionDataStore = new FusionCharts.DataStore();
    // After that we are creating a DataTable by passing our data and schema as arguments
    const fusionTable = fusionDataStore.createDataTable(data, schema);

    $('document').ready(function() {
        $('#chart-container').insertFusionCharts({
            type: 'timeseries',
            width: '700',
            height: '400',
            dataFormat: 'json',
            dataSource: {
                data: fusionTable,
                caption: {
                    text: 'Sales Analysis'
                },
                subcaption: {
                    text: 'Grocery'
                },
                yAxis: [{
                    plot: {
                        value: 'Grocery Sales Value',
                        type: 'line'
                    },
                    format: {
                        prefix: '$'
                    },
                    title: 'Sale Value'
                }]
            }
        });
    });
});

In the above code:

  • A DataStore is created by declaring a new constant fusionDataStore.
  • Define the chart configuration in the FusionCharts constructor:

    • Set the type as timeseries.

    • Set the chart container as container using the renderAt property.

    • Set the width and height (in pixels).

    • Set the name of the DataTable as the value of the data property of dataSource.

    • Set the data to create the chart.

    • Specify the caption of the chart using text attribute in the caption object.

Also, include the following code in your .html file:


<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Jquery FusionTime</title>
  </head>
  <body>
    <div id="chart-container">FusionCharts will render here...</div>
    <script src="./bundle.js"></script>
  </body>
</html>


<!DOCTYPE html>
<html>
  <head>
    <title>jQuery FusionCharts Plugin Sample</title>
    <script
      type="text/javascript"
      src="https://code.jquery.com/jquery-3.3.1.min.js"
    ></script>
    <script
      type="text/javascript"
      src="https://unpkg.com/fusioncharts/fusioncharts.js"
    ></script>
    <script
      type="text/javascript"
      src="https://unpkg.com/[email protected]/fusioncharts.timeseries.js"
    ></script>
    <script
      type="text/javascript"
      src="https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"
    ></script>
  </head>
  <body>
    <div id="chart-container">FusionCharts will render here...</div>

    <script src="./index.js"></script>
  </body>
</html>


<!DOCTYPE html>
<html>
  <head>
    <title>jQuery FusionCharts Plugin Sample</title>
    <script
      type="text/javascript"
      src="https://code.jquery.com/jquery-3.3.1.min.js"
    ></script>
    <script
      type="text/javascript"
      src="https://unpkg.com/fusioncharts/fusioncharts.js"
    ></script>
    <script
      type="text/javascript"
      src="https://unpkg.com/[email protected]/fusioncharts.timeseries.js"
    ></script>
    <script
      type="text/javascript"
      src="https://rawgit.com/fusioncharts/fusioncharts-jquery-plugin/develop/dist/fusioncharts.jqueryplugin.min.js"
    ></script>
  </head>
  <body>
    <div id="chart-container">FusionCharts will render here...</div>

    <script src="./index.js"></script>
  </body>
</html>

That's it! Your first chart in jQuery using FusionTime is ready.

Create a Chart in Vue

FusionTime is a JavaScript charting library that helps you visualize, and explore time-series data. In FusionTime, you get lots of out-of-the-box interactive features, such as time navigator, date range selectors, tooltips with crosslines, interactive legend and more. These features enhance the experience of exploring and understanding time-series data.

We have built a simple vue-fusioncharts component, which provides bindings for FusionTime. The vue-fusioncharts directive allows you to easily add interactive time-series charts to any Vue project.

In this page, we'll see how to install FusionTime and render an interactive time-series chart using the vue-fusioncharts directive.

Installation

Since FusionTime is distributed along with FusionCharts Suite, download/install the FusionCharts package to get access to FusionTime and other chart types of the FusionCharts Suite. To install follow the steps below:

To install FusionTime and the vue-fusioncharts component via npm follow the steps below:
1. Install the vue-fusioncharts component

$ npm install vue-fusioncharts --save

2. Install fusioncharts package

$ npm install fusioncharts --save

To install FusionTime and the vue-fusioncharts component follow the steps below:
1. Include Vue core library.
2. Include the vue-fusioncharts component.
3. Include the FusionCharts JavaScript files which can be downloaded from here.
4. Include the FusionTime file to render time-series charts

<head>
    <!-- Step 1 - Including vue  -->
    <script type="text/javascript" src="https://unpkg.com/[email protected]"></script>
    <!-- Step 2 - Including vue-fusioncharts component -->
    <script type="text/javascript" src="https://unpkg.com/vue-fusioncharts/dist/vue-fusioncharts.min.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <!-- Step 4 - Including the FusionTime File -->
    <script type="text/javascript" src="https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.timeseries.js"></script>
</head>

To install FusionTime and the vue-fusioncharts component follow the steps below:
1. Include Vuecore library.
2. Include the vue-fusioncharts component.
3. Include the FusionCharts JavaScript files which can be downloaded from here.
4. Include the FusionTime file to render time-series charts.

<head>
    <!-- Step 1 - Including vue  -->
    <script type="text/javascript" src="path/to/local/vue.js"></script>
    <!-- Step 2 - Including vue-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/vue-fusioncharts.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Step 4 - Including the FusionTime File -->
    <script type="text/javascript" src="path/to/local/fusioncharts.timeseries.js"></script>
</head>

Usage

The two methods to add vue-fusioncharts component to your project are:

  • Register globally as a plugin
  • Register locally in your component

Registering globally as a plugin

  • Import vue, vue-fusioncharts, and FusionCharts in main app file.
import Vue from `vue`;
import VueFusionCharts from 'vue-fusioncharts';

// import FusionCharts modules and resolve dependency
import FusionCharts from 'fusioncharts';
import TimeSeries from 'fusioncharts/fusioncharts.timeseries;
  • Register it as a plugin in your Vue object
Vue.use(VueFusionCharts, FusionCharts, TimeSeries);

The above method to add the component to your project is recommended only if you want to avail the vue-fusioncharts component from anywhere in the application.

Registering locally in your component

  • Import the chart component from vue-fusioncharts component package to your component file and use Vue.component to register it locally.
import Vue from `vue`;
import VueFusionChartsComponent from 'vue-fusioncharts/component';

// import FusionCharts modules and resolve dependency
import FusionCharts from 'fusioncharts';
import TimeSeries from 'fusioncharts/fusioncharts.timeseries;

const vueFusionCharts = VueFusionChartsComponent(FusionCharts, TimeSeries);

Vue.component('fusioncharts', vueFusionCharts);

The above method to add the component in your project is recommended when you want to restrict the availability of vue-fusioncharts component to a specific file or folder.

Create Your First Chart

Let's create a timeseries charts using vue-fusioncharts component showing Daily sales of a grocery store.

The chart will look as shown below:

Loading data for chart…

The data for the above chart is too big to be displayed here. The table below shows the sample data of the above chart:

Time Sales
01-Feb-11 8866
02-Feb-11 2174
03-Feb-11 2084
04-Feb-11 1503
05-Feb-11 4928
06-Feb-11 4667
07-Feb-11 1064

FusionTime accepts a DataTable as the data source. DataTable is the tabular representation of data. To create the DataTable, you need to provide the following:

  • schema - which defines the properties of the columns.
  • data - which contains the values of each row and column of the DataTable.

For an instance of FusionTime, you can create n number of DataTables, but only one DataStore.

Now, let's learn how to prepare the schema and the data of the DataTable.

Create the schema

The schema outlines each column represented in the above table. The schema contains an array which has multiple objects created in it. Each object represents a column of the above table.

name and type are mandatory keys for each object. If the object type is time then format is also a mandatory key.

To define the schema, let's create a schema.json file and copy the following code:

It is not mandatory to create the schema in a different .json file. You can also define the schema within the .html file.

Let schema = [{
    "name": "Time",
    "type": "date",
    "format": "%-m/%-d/%Y"
}, {
    "name": "Sales",
    "type": "number"
}]

In the above code:

  • schema is the variable in which the array is stored.
  • Each object of a schema maps to a column of the tabular representation of the data.
  • The JSON object has the following attributes:
    • name - Specify the name of the column of the tabular representation of data
    • type - Specify the type of the column.
    • format - Specify the input format of the date as per your data. In this example, the format is %-m/%-d/%Y. To know more on date formats click here.

Now that we have the schema ready, let's work on the data.

Create data

Data can be provided either in JSON format or 2D array format. We will use the 2D array format.

Data for the above chart is too big to be shown here. A sample of it has been used in the data object defined below:

var data = [
    [
        "1/4/2011",
        16.448
    ],
    [
        "1/5/2011",
        272.736
    ],
    [
        "1/5/2011",
        11.784
    ],
    [
        "1/5/2011",
        3.54
    ],
    [
        "1/6/2011",
        19.536
    ],
    [
        "1/7/2011",
        2573.82
    ],
]

Create a new data.json file, and copy the above code there. Next, copy the entire data and replace it with the content of the data object in your 'data.json' file.

It is not mandatory to create a data.json file. You can also do the same in your HTML file.

In the above code:

  • data is the variable in which the data array is stored.
  • Each object in the data array corresponds to a row in the tabular representation of the data.
  • Each element in an object is represented by each object of the schema. The values in each object of the array represent the following:
    • Time according to the format
    • Total sales amount

We are all set with our data to create the chart.

By default, FusionTime applies the average function to aggregate the data and display on the chart. You can change the aggregate function from average to any other numeric calculation. To know more, click here.

Now, let's create the files to render the above chart.

Render the chart

To render the chart, create a .js file and copy the following code:



import Vue from 'vue';
import VueFusionCharts from 'vue-fusioncharts';
import FusionCharts from 'fusioncharts';
import TimeSeries from 'fusioncharts/fusioncharts.timeseries';

// register VueFusionCharts
Vue.use(VueFusionCharts, FusionCharts, TimeSeries);

const jsonify = res => res.json();
const dataFetch = fetch(
'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
).then(jsonify);
const schemaFetch = fetch(
'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
).then(jsonify);

const chart = new Vue({
  el: '#app',
  data: {
    width: '700',
    height: '400',
    type: 'timeseries',
    dataFormat: 'json',
    dataSource: {
      data: null,
      caption: {
        text: 'Sales Analysis'
      },
      subcaption: {
        text: 'Grocery'
      },
      yAxis: [{
        plot: {
          value: 'Grocery Sales Value',
          type: 'line'
        },
        format: {
          prefix: '$'
        },
        title: 'Sale Value'
      }]
    }
  },
  mounted: function() {
    // In this Promise we will create our DataStore and using that we will create a custom DataTable which takes two
    // parameters, one is data another is schema.
    Promise.all([dataFetch, schemaFetch]).then(res => {
      const data = res[0];
      const schema = res[1];
      // First we are creating a DataStore
      const fusionDataStore = new FusionCharts.DataStore();
      // After that we are creating a DataTable by passing our data and schema as arguments
      const fusionTable = fusionDataStore.createDataTable(data, schema);
      // After that we simply mutated our timeseries datasource by attaching the above
      // DataTable into its data property.
      this.dataSource.data = fusionTable;
    });
  }
});


<html lang="en">
  <head>
  </head>
  <body>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/[email protected]/fusioncharts.js"></script>
    <script src="https://unpkg.com/[email protected]/fusioncharts.timeseries.js"></script>
    <!-- If you want to use vue-fusioncharts as a plugin -->
    <script src="https://unpkg.com/[email protected]/dist/vue-fusioncharts.js"></script>
    <!-- If you want to use vue-fusioncharts as a component -->
    <!-- <script src="https://unpkg.com/[email protected]/component/index.js"></script> -->
    <script>
      // Register vue-fusioncharts as a plugin if you want to use it globally
      Vue.use(VueFusionCharts, FusionCharts);

      // Links to fetch data and schema for TimeSeries chart
      const jsonify = res => res.json();
      var dataFetch = fetch(
        'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
      ).then(jsonify);
      var schemaFetch = fetch(
        'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
      ).then(jsonify);

      // Create vue-fusioncharts component
      // let vFC = VueFusionChartsComponent(FusionCharts);

      var app = new Vue({
        el: '#app',
        // Register the vue-fusioncharts component you created earlier if you want to use it locally
        // components: { fusioncharts: vFC },
        data: {
          width: '700',
          height: '400',
          type: 'timeseries',
          dataFormat: 'json',
          displayChart: false,
          dataSource: {
            // Initially data is set as null
            data: null,
            caption: {
              text: 'Sales Analysis'
            },
            subcaption: {
              text: 'Grocery'
            },
            yAxis: [
              {
                plot: {
                  value: 'Grocery Sales Value',
                  type: 'line'
                },
                format: {
                  prefix: '$'
                },
                title: 'Sale Value'
              }
            ]
          }
        },
        mounted: function() {
          // In this Promise we will create our DataStore and using that we will create a custom DataTable which takes two
          // parameters, one is data another is schema.
          Promise.all([dataFetch, schemaFetch]).then(res => {
            const data = res[0];
            const schema = res[1];
            // First we are creating a DataStore
            const fusionDataStore = new FusionCharts.DataStore();
            // After that we are creating a DataTable by passing our data and schema as arguments
            const fusionTable = fusionDataStore.createDataTable(data, schema);
            // After that we simply mutated our timeseries datasource by attaching the above
            // DataTable into its data property.
            this.dataSource.data = fusionTable;
          });
        }
      });
    </script>
  </body>
</html>


<html lang="en">
  <head>
  </head>
  <body>
    <script type="text/javascript" src="path/to/local/vue.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <script type="text/javascript" src="path/to/local/fusioncharts.timeseries.js"></script>
    <!-- If you want to use vue-fusioncharts as a plugin -->
    <script type="text/javascript" src="path/to/local/vue-fusioncharts.js"></script>
    <!-- If you want to use vue-fusioncharts as a component -->
    <!-- <script src="https://unpkg.com/[email protected]/component/index.js"></script> -->
    <script>
      // Register vue-fusioncharts as a plugin if you want to use it globally
      Vue.use(VueFusionCharts, FusionCharts);

      // Links to fetch data and schema for TimeSeries chart
      const jsonify = res => res.json();
      var dataFetch = fetch(
        'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json'
      ).then(jsonify);
      var schemaFetch = fetch(
        'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json'
      ).then(jsonify);

      // Create vue-fusioncharts component
      // let vFC = VueFusionChartsComponent(FusionCharts);

      var app = new Vue({
        el: '#app',
        // Register the vue-fusioncharts component you created earlier if you want to use it locally
        // components: { fusioncharts: vFC },
        data: {
          width: '700',
          height: '400',
          type: 'timeseries',
          dataFormat: 'json',
          displayChart: false,
          dataSource: {
            // Initially data is set as null
            data: null,
            caption: {
              text: 'Sales Analysis'
            },
            subcaption: {
              text: 'Grocery'
            },
            yAxis: [
              {
                plot: {
                  value: 'Grocery Sales Value',
                  type: 'line'
                },
                format: {
                  prefix: '$'
                },
                title: 'Sale Value'
              }
            ]
          }
        },
        mounted: function() {
          // In this Promise we will create our DataStore and using that we will create a custom DataTable which takes two
          // parameters, one is data another is schema.
          Promise.all([dataFetch, schemaFetch]).then(res => {
            const data = res[0];
            const schema = res[1];
            // First we are creating a DataStore
            const fusionDataStore = new FusionCharts.DataStore();
            // After that we are creating a DataTable by passing our data and schema as arguments
            const fusionTable = fusionDataStore.createDataTable(data, schema);
            // After that we simply mutated our timeseries datasource by attaching the above
            // DataTable into its data property.
            this.dataSource.data = fusionTable;
          });
        }
      });
    </script>
  </body>
</html>

In the above code:

  • Include Vue and vue-fusioncharts component.

  • Include the fusioncharts library.

  • Include the TimeSeries as chart type.

  • Include data.json and schema.json files.

  • Define the chart configuration in the FusionCharts constructor:

    • Set the type as timeseries.

    • Set the chart container as container using the renderAt property.

    • Set the width and height (in pixels).

    • Set the name of the DataTable as the value of the data property of dataSource.

    • Set the data to create the chart.

    • Specify the caption of the chart using text attribute in the caption object.

  • Create an empty storage as fusionDataStore using FusionCharts.DataStore.

  • Create a DataTable within the empty storage using fusionDataStore.createDataTable and pass the schema and data to the DataTable.

The HTML template of the above example is:

<div id="app">
  <fusioncharts
    :width="width"
    :height="height"
    :type="type"
    :dataFormat="dataFormat"
    :dataSource="dataSource"
  >
    FusionCharts will render here...
  </fusioncharts>
</div>

Create a Chart in Angular

FusionTime is a JavaScript charting library that helps you visualize, and explore time-series data. In FusionTime, you get lots of out-of-the-box interactivity, such as time navigator, date range selectors, tooltips with crosslines, interactive legend and more. These features enhance the experience of exploring and understanding time-series data.

We have built a simple angular-fusioncharts component which provides bindings for FusionTime. The angular-fusioncharts directive allows you to easily add interactive time-series charts to any Angular project.

In this page, we'll see how to install FusionTime and render an interactive time-series chart using the angular-fusioncharts directive.

Installation

Since FusionTime is distributed along with FusionCharts Suite, download/install the FusionCharts package to get access to FusionTime and other chart types of the FusionCharts Suite. To install, follow the steps below:

Step 1: Install angular-fusioncharts

$ npm install angular-fusioncharts --save

Step 2: Install fusioncharts core library

$ npm install fusioncharts --save

That completes the installation of FusionTime and the angular-fusioncharts component.

Create Your First Chart

Let's create a time-series chart using angular-fusioncharts directive showing Daily sales of a grocery store.

The chart is shown below:

Loading data for chart…

The data for the above chart is too big to be displayed here. The table below shows the sample data of the above chart:

Time Sales
01-Feb-11 8866
02-Feb-11 2174
03-Feb-11 2084
04-Feb-11 1503
05-Feb-11 4928
06-Feb-11 4667
07-Feb-11 1064

FusionTime accepts a DataTable as the data source. DataTable is the tabular representation of data. To create the DataTable, you need to provide the following:

  • schema - which defines the properties of the columns.
  • data - which contains the values of each row and column of the DataTable

For an instance of FusionTime, you can create n number of DataTables, but only one DataStore.

Next, let's learn how to prepare the schema and the data of the DataTable.

Create the schema

The schema outlines each column represented in the above table. The schema contains an array which has multiple objects created in it. Each object represents a column of the above table.

name and type are mandatory keys for each object. If the object type is time then format is also a mandatory key.

To define the schema, let's create a schema.json file and copy the following code:

It is not mandatory to create the schema in a different .json file. You can also define the schema within the .html file.

[{
    "name": "Time",
    "type": "date",
    "format": "%-m/%-d/%Y"
}, {
    "name": "Sales",
    "type": "number"
}]

In the above code:

  • schema is the variable in which the array is stored.
  • Each object of a schema maps to a column of the tabular representation of the data.
  • The JSON object has the following attributes:
    • name - Specify the name of the column of the tabular representation of data
    • type - Specify the type of the column.
    • format - Specify the input format of the date as per your data. In this example, the format is %-m/%-d/%Y. To know more on date formats click here.

Now that we have the schema ready, let's work on the data.

Create data

Data can be provided either in JSON format or 2D array format. We will use the 2D array format.

Data for the above chart is too big to be shown here. A sample of it has been used in the data object defined below:

[
    [
        "1/4/2011",
        16.448
    ],
    [
        "1/5/2011",
        272.736
    ],
    [
        "1/5/2011",
        11.784
    ],
    [
        "1/5/2011",
        3.54
    ],
    [
        "1/6/2011",
        19.536
    ],
    [
        "1/7/2011",
        2573.82
    ],
]

Create a new data.json file, and copy the above code there. Next, copy the entire data and replace it with the content of the data object in your 'data.json' file.

It is not mandatory to create a data.json file. You can also do the same in your HTML file.

In the above code:

  • data is the variable in which the data array is stored.
  • Each object in the data array corresponds to a row in the tabular representation of the data.
  • Each element in an object is represented by each object of the schema. The values in each object of the array represent the following:
    • Time according to the format
    • Total sales amount

We are all set with our data to create the chart.

By default, FusionTime applies the average function to aggregate the data and display on the chart. You can change the aggregate function from average to any other numeric calculation. To know more, click here.

Now, let's create the files to render the above chart.

Render the chart

To render the chart follow the steps below:

Step 1: In app.module.ts include the necessary files and add the dependency.

  • Import angular-fusioncharts in the root @NgModule.
  • Import FusionCharts library in the root @NgModule.
  • Import FusionTime in the root @NgModule.
  • Pass the fusioncharts library and chart modules.
// app.module.ts
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';
// Import angular-fusioncharts
import { FusionChartsModule } from 'angular-fusioncharts';
// Import FusionCharts library and chart modules
import * as FusionCharts from 'fusioncharts';
import * as TimeSeries from 'fusioncharts/fusioncharts.timeseries'; // Import timeseries
// Pass the fusioncharts library and timeseries modules
FusionChartsModule.fcRoot(FusionCharts, TimeSeries);
@NgModule({
  declarations: [AppComponent],
  imports: [
    BrowserModule,
    // Specify FusionChartsModule as import
    FusionChartsModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule {}

Step 2: Add data to the angular app.component.ts

Set the JSON data within the AppComponent class as shown below:

// In app.component.ts
import { Component } from '@angular/core';
import * as FusionCharts from 'fusioncharts';
const dataUrl =
'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/data/line-chart-with-time-axis-data.json';
const schemaUrl =
'https://s3.eu-central-1.amazonaws.com/fusion.store/ft/schema/line-chart-with-time-axis-schema.json';
@Component({
  selector: 'app',
  templateUrl: './app.component.html'
})
export class AppComponent {
  dataSource: any;
  type: string;
  width: string;
  height: string;
  constructor() {
    this.type = 'timeseries';
    this.width = '700';
    this.height = '400';
    this.dataSource = {
      data: null,
      caption: {
        text: 'Sales Analysis'
      },
      subcaption: {
        text: 'Grocery'
      },
      yAxis: [
        {
          plot: {
            value: 'Grocery Sales Value',
            type: 'line'
          },
          format: {
            prefix: '$'
          },
          title: 'Sale Value'
        }
      ]
    };
    this.fetchData();
  }
  fetchData() {
    let jsonify = res => res.json();
    let dataFetch = fetch(dataUrl).then(jsonify);
    let schemaFetch = fetch(schemaUrl).then(jsonify);
    Promise.all([dataFetch, schemaFetch]).then(res => {
      let data = res[0];
      let schema = res[1];
      let fusionTable = new FusionCharts.DataStore().createDataTable(
        data,
        schema
      ); // Instance of DataTable to be passed as data in dataSource
      this.dataSource.data = fusionTable;
    });
  }
}

Step 3: Now use the fusioncharts component in app.component.html.

Create the chart container and set the following:

  • Chart width and height.
  • The data source.
<div>
  <fusioncharts
    [type]="type"
    [width]="width"
    [height]="height"
    [dataSource]="dataSource"
  ></fusioncharts>
</div>

That's it! Your first chart in Angular using FusionTime is ready.

Create a Chart in React

FusionTime is a JavaScript charting library that helps you visualize, and explore time-series data. In FusionTime, you get lots of out-of-the-box interactive features, such as time navigator, date range selectors, tooltips with crosslines, interactive legend and more. These features enhance the experience of exploring and understanding time-series data

We have built a simple react-fusioncharts component, which provides bindings for FusionTime. The react-fusioncharts component allows you to easily add interactive time-series charts to any React project.

In this page, we'll see how to install FusionTime and render an interactive time-series chart using the react-fusioncharts component.

Installation

Since FusionTime is distributed along with FusionCharts Suite, download/install the FusionCharts package to get access to FusionTime and other chart types of the FusionCharts Suite. To install follow the steps below:

To install FusionTime and the react-fusioncharts component via npm follow the steps below:
1. Install the react-fusioncharts component

$ npm install react-fusioncharts --save

2. Install fusioncharts package

$ npm install fusioncharts --save

To install FusionTime and the react-fusioncharts component, follow the steps below:
  1. Include the React core library.
  2. Include Babel for JSX transpiling.
  3. Include the FusionCharts JavaScript files from CDN.
  4. Include FusionTime file.
  5. Include the react-fusioncharts module.

<head>
    <!-- Including react -->
    <script type="text/javascript" src="https://unpkg.com/react@16/umd/react.development.js"></script>
    <!-- Including react-dom -->
    <script type="text/javascript" src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>
    <!-- Including babel -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-standalone/6.21.1/babel.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src="https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <!-- Including the fusiontime file to render charts -->
    <script type="text/javascript" src="https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.timeseries.js"></script>
    <!-- Including react-fusioncharts component -->
    <script type="text/javascript" src=" https://unpkg.com/[email protected]/dist/react-fusioncharts.js"></script>
</head>

To install the FusionCharts Suite and the react-fusioncharts component, follow the steps below:
  1. Include the Reactcore library.
  2. Include Babelfor JSX transpiling.
  3. Include the FusionCharts JavaScript files, which can be downloaded from here.
  4. Include the FusionTime file
  5. Include the react-fusioncharts component.
The consolidated code is shown below:

<head>
    <!-- Step 1 - Including react  -->
    <script type="text/javascript" src="path/to/local/react.js"></script>
    <script type="text/javascript" src="path/to/local/react-dom.js"></script>
    <!-- Step 2 - Including Babel for JSX transpiling -->
    <script type="text/javascript" src="path/to/local/babel-core.js"></script>
    <!-- Step 3 - Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Step 4 - Including FusionTime file -->
    <script type="text/javascript" src=" path/to/local/fusioncharts.timeseries.js"></script>
    <!-- Step 5 - Including the react-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/react-fusioncharts.js"></script>
</head>

Create Your First Chart

Let's create a time-series chart using react-fusioncharts component showing Online sales of a SuperStore.

The chart will look as shown below:

Loading data for chart…

The data for the above chart is too big to be displayed here. The table below shows the sample data of the above chart:

Time Sales
1/4/2011 16.448
1/5/2011 272.736
1/5/2011 11.784
1/5/2011 3.54
1/6/2011 19.536
1/7/2011 2573.82
1/7/2011 609.98

FusionTime accepts a DataTable as the data source. DataTable is the tabular representation of data. To create the DataTable, you need to provide the following:

  • schema - which defines the properties of the columns.
  • data - which contains the values of each row and column of the DataTable.

For an instance of FusionTime, you can create n number of DataTables, but only one DataStore.

Now, let's learn how to prepare the schema and the data of the DataTable.

Create the schema

The schema outlines each column represented in the above table. The schema contains an array which has multiple objects created in it. Each object represents a column of the above table.

name and type are mandatory keys for each object. If the object type is time then format is also a mandatory key.

To define the schema, let's create a schema.json file and copy the following code:

It is not mandatory to create the schema in a different .json file. You can also define the schema within the .html file.

[{
    "name": "Time",
    "type": "date",
    "format": "%-m/%-d/%Y"
}, {
    "name": "Sales",
    "type": "number"
}]

In the above code:

  • schema is the variable in which the array is stored.
  • Each object of a schema maps to a column of the tabular representation of the data.
  • The JSON object has the following attributes:
    • name - Specify the name of the column of the tabular representation of data
    • type - Specify the type of the column.
    • format - Specify the input format of the date as per your data. In this example, the format is %-m/%-d/%Y. To know more on date formats click here.

Now that we have the schema ready, let's work on the data.

Create data

Data can be provided either in JSON format or 2D array format. We will use the 2D array format.

Data for the above chart is too big to be shown here. A sample of it has been used in the data object defined below:

var data = [
    [
        "1/4/2011",
        16.448
    ],
    [
        "1/5/2011",
        272.736
    ],
    [
        "1/5/2011",
        11.784
    ],
    [
        "1/5/2011",
        3.54
    ],
    [
        "1/6/2011",
        19.536
    ],
    [
        "1/7/2011",
        2573.82
    ],
]

Create a new data.json file, and copy the above code there. Next, copy the entire data and replace it with the content of the data object in your 'data.json' file.

It is not mandatory to create a data.json file. You can also do the same in your HTML file.

In the above code:

  • data is the variable in which the data array is stored.
  • Each object in the data array corresponds to a row in the tabular representation of the data.
  • Each element in an object is represented by each object of the schema. The values in each object of the array represent the following:
    • Time according to the format
    • Total sales amount

We are all set with our data to create the chart.

By default, FusionTime applies the average function to aggregate the data and display on the chart. You can change the aggregate function from average to any other numeric calculation. To know more, click here.

Now, let's create the files to render the above chart.

Render the chart

To render the chart, create a .js file and copy the following code:


// Step 1 - Including react
import React from 'react';

// Step 2 - Including the react-fusioncharts component
import FusionCharts from 'fusioncharts';

// Step 3 - Including the fusiontime file
import TimeSeries from 'fusioncharts/fusioncharts.timeseries';
import ReactFC from '../lib/ReactFC';

// Step 4 - Adding the chart as dependency to the core fusioncharts
ReactFC.fcRoot(FusionCharts, TimeSeries);

// Step 5 - Creating the JSON object to store the chart configurations
const jsonify = res => res.json();
const dataFetch = fetch(
'https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/master/assets/datasources/fusiontime/online-sales-single-series-area-data-plot/data.json'
).then(jsonify);
const schemaFetch = fetch( 'https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/master/assets/datasources/fusiontime/online-sales-single-series-area-data-plot/schema.json'
).then(jsonify);

class SimpleTimeSeries extends React.Component {
    constructor(props) {
        super(props);
        // In this method we are fetching our data and schema from remote URLs and creating our DataTable
        this.onFetchData = this.onFetchData.bind(this);
        this.state = {
            timeseriesDs: {
                type: 'timeseries',
                renderAt: 'container',
                width: '600',
                height: '400',
                dataSource: {
                    caption: { text: 'Online Sales of a SuperStore in the US' },
                    data: null,
                    yAxis: [{
                        plot: [{
                            value: 'Sales ($)'
                        }]
                    }]
                }
            }
        };
    }
    // We are creating our DataStore immediately after a component is mounted
    componentDidMount() {
        this.onFetchData();
    }
    onFetchData() {
        Promise.all([dataFetch, schemaFetch]).then(res => {
            const data = res[0];
            const schema = res[1];
            // Here we are creating our DataTable
            const fusionTable = new FusionCharts.DataStore().createDataTable(data, schema);
            const timeseriesDs = Object.assign({}, this.state.timeseriesDs);
            timeseriesDs.dataSource.data = fusionTable;
            this.setState({
                timeseriesDs
            });
        });
    }
    render() {
        return (
        
{this.state.timeseriesDs.dataSource.data ? ( ) : ( 'loading' )}
); } }

<html>
<head>
    <!-- Including react -->
    <script type="text/javascript" src=" https://unpkg.com/react@16/umd/react.development.js"></script>
    <!-- Including react-dom -->
    <script type="text/javascript" src=" https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>
    <!-- Including babel -->
    <script type="text/javascript" src=" https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src=" https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.js"></script>
    <!-- Including the fusiontime library to render charts -->
    <script type="text/javascript" src=" https://cdn.fusioncharts.com/fusioncharts/latest/fusioncharts.timeseries.js"></script>
    <!-- Including react-fusioncharts component -->
    <script type="text/javascript" src=" https://unpkg.com/[email protected]/dist/react-fusioncharts.min.js"></script>
    <script type="text/jsx">
        ReactFC.fcRoot(FusionCharts);

        const jsonify = res => res.json();
        const dataFetch = fetch(  'https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/fusiontime-beta-release/charts-resources/fusiontime/online-sales-single-series/data.json').then(jsonify);

        const schemaFetch = fetch('https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/fusiontime-beta-release/charts-resources/fusiontime/online-sales-single-series/schema.json').then(jsonify);
    </script>
    <script type="text/babel">
        class ChartViewer extends React.Component {
            constructor(props) {
                super(props);
                this.onFetchData = this.onFetchData.bind(this);
                this.state = {
                    timeseriesDs: {
                        type: 'timeseries',
                        renderAt: 'container',
                        width: '600',
                        height: '400',
                        dataSource: {
                            caption: { text: 'Online Sales of a SuperStore in the US' },
                            data: null,
                            yAxis: [{
                                plot: [{
                                    value: 'Sales ($)'
                                }]
                            }]
                        }
                    }
                };
            }
            componentDidMount() {
                this.onFetchData();
            }
            onFetchData() {
                Promise.all([dataFetch, schemaFetch]).then(res => {
                    const data = res[0];
                    const schema = res[1];
                    const fusionTable = new FusionCharts.DataStore().createDataTable(data, schema);
                    const timeseriesDs = Object.assign({}, this.state.timeseriesDs);
                    timeseriesDs.dataSource.data = fusionTable;
                    this.setState({
                        timeseriesDs
                    });
                });
            }

            render() {
                return (
                <div>
                {this.state.timeseriesDs.dataSource.data ? (
                <ReactFC {...this.state.timeseriesDs} />
                ) : (
                'loading'
                )}
                </div>
                );
            }
        }

        ReactDOM.render(
            <ChartViewer />,
            document.getElementById('chart-container')
        );
    </script>
</head>
<body>
    <div id='chart-container'></div>
</body>
</html>


<html>
<head>
    <!-- Including react -->
    <script type="text/javascript" src="path/to/local/react.development.js"></script>
    <!-- Including react-dom -->
    <script type="text/javascript" src="path/to/local/react-dom.development.js"></script>
    <!-- Including babel -->
    <script type="text/javascript" src="path/to/local/babel.min.js"></script>
    <!-- Including the fusioncharts core library -->
    <script type="text/javascript" src="path/to/local/fusioncharts.js"></script>
    <!-- Including the fusiontime library to render charts -->
    <script type="text/javascript" src="path/to/local/fusioncharts.timeseries.js"></script>
    <!-- Including react-fusioncharts component -->
    <script type="text/javascript" src="path/to/local/react-fusioncharts.min.js"></script>
    <script type="text/babel">
    ReactFC.fcRoot(FusionCharts);

    const jsonify = res => res.json();
    const dataFetch = fetch(       'https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/fusiontime-beta-release/charts-resources/fusiontime/online-sales-single-series/data.json').then(jsonify);
    const schemaFetch = fetch('https://raw.githubusercontent.com/fusioncharts/dev_centre_docs/fusiontime-beta-release/charts-resources/fusiontime/online-sales-single-series/schema.json').then(jsonify);
    </script>
        <script type="text/jsx">
        class ChartViewer extends React.Component {
            constructor(props) {
                super(props);
                this.onFetchData = this.onFetchData.bind(this);
                this.state = {
                    timeseriesDs: {
                        type: 'timeseries',
                        renderAt: 'container',
                        width: '600',
                        height: '400',
                        dataSource: {
                            caption: { text: 'Online Sales of a SuperStore in the US' },
                            data: null,
                            yAxis: [{
                                plot: [{
                                    value: 'Sales ($)'
                                }]
                            }]
                        }
                    }
                };
            }
            componentDidMount() {
                this.onFetchData();
            }
            onFetchData() {
                Promise.all([dataFetch, schemaFetch]).then(res => {
                    const data = res[0];
                    const schema = res[1];
                    const fusionTable = new FusionCharts.DataStore().createDataTable(data, schema);
                    const timeseriesDs = Object.assign({}, this.state.timeseriesDs);
                    timeseriesDs.dataSource.data = fusionTable;
                    this.setState({
                        timeseriesDs
                    });
                });
            }

            render() {
                return (
                <div>
                {this.state.timeseriesDs.dataSource.data ? (
                <ReactFC {...this.state.timeseriesDs} />
                ) : (
                'loading'
                )}
                </div>
                );
            }
        }
        ReactDOM.render(
        <ChartViewer />,
        document.getElementById('chart-container')
        );
    </script>
</head>
<body>
    <div id='chart-container'></div>
</body>
</html>

In the above code:

  • Create a React Component ChartViewer.
  • Add timeseriesDs in component state.
  • Include the fusioncharts library.
  • Include data.json and schema.json files.
  • Define the chart configuration in the FusionCharts constructor:
    • Set the type as timeseries.
    • Set the chart container as container using the renderAt property.
    • Set the width and height (in pixels).
    • Set the name of the DataTable as the value of the data property of dataSource.
    • Set the data to create the chart.
    • Specify the caption of the chart using text attribute in caption object.
  • Create an empty storage as fusionDataStore using FusionCharts.DataStore.
  • Create a DataTable within the empty storage using fusionDataStore.createDataTable and pass the schema and data to the DataTable.